# coding: utf-8

"""
    XI Sdk Resellers

    For resellers seeking to innovate with Ingram Micro's API solutions, automate your eCommerce experience with our array of API's and webhooks to craft a seamless journey for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.async_order_create_dto_lines_inner_end_user_info_inner import AsyncOrderCreateDTOLinesInnerEndUserInfoInner
from typing import Optional, Set
from typing_extensions import Self

class AsyncOrderCreateDTOLinesInner(BaseModel):
    """
    AsyncOrderCreateDTOLinesInner
    """ # noqa: E501
    customer_line_number: Optional[StrictStr] = Field(default=None, description="The reseller's line item number for reference in their system.", alias="customerLineNumber")
    ingram_part_number: Optional[StrictStr] = Field(default=None, description="Unique IngramMicro part number.", alias="ingramPartNumber")
    quantity: Optional[StrictStr] = Field(default=None, description="The quantity of the line item.")
    unit_price: Optional[StrictStr] = Field(default=None, description="Unit Price of Item", alias="unitPrice")
    special_bid_number: Optional[StrictStr] = Field(default=None, alias="specialBidNumber")
    end_user_price: Optional[StrictStr] = Field(default=None, alias="endUserPrice")
    notes: Optional[StrictStr] = None
    end_user_info: Optional[List[AsyncOrderCreateDTOLinesInnerEndUserInfoInner]] = Field(default=None, description="The contact information for the end user/customer provided by the reseller. Used to determine pricing and discounts.", alias="endUserInfo")
    __properties: ClassVar[List[str]] = ["customerLineNumber", "ingramPartNumber", "quantity", "unitPrice", "specialBidNumber", "endUserPrice", "notes", "endUserInfo"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AsyncOrderCreateDTOLinesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in end_user_info (list)
        _items = []
        if self.end_user_info:
            for _item in self.end_user_info:
                if _item:
                    _items.append(_item.to_dict())
            _dict['endUserInfo'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AsyncOrderCreateDTOLinesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customerLineNumber": obj.get("customerLineNumber"),
            "ingramPartNumber": obj.get("ingramPartNumber"),
            "quantity": obj.get("quantity"),
            "unitPrice": obj.get("unitPrice"),
            "specialBidNumber": obj.get("specialBidNumber"),
            "endUserPrice": obj.get("endUserPrice"),
            "notes": obj.get("notes"),
            "endUserInfo": [AsyncOrderCreateDTOLinesInnerEndUserInfoInner.from_dict(_item) for _item in obj["endUserInfo"]] if obj.get("endUserInfo") is not None else None
        })
        return _obj


